osgVolume::CompositeLayer Class Reference

`#include <Layer>`

Inheritance diagram for osgVolume::CompositeLayer:

## Classes

struct | NameLayer

## Public Member Functions

| CompositeLayer ()
| CompositeLayer (const CompositeLayer &compositeLayer, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgVolume, CompositeLayer)
void | clear ()
void | setFileName (unsigned int i, const std::string &filename)
const std::string & | getFileName (unsigned int i) const
void | setLayer (unsigned int i, Layer *layer)
template<class T>
void | setLayer (unsigned int i, const osg::ref_ptr< T > &layer)
Layer * | getLayer (unsigned int i)
const Layer * | getLayer (unsigned int i) const
void | addLayer (Layer *layer)
template<class T>
void | addLayer (const osg::ref_ptr< T > &layer)
void | removeLayer (unsigned int i)
unsigned int | getNumLayers () const
bool | requiresUpdateTraversal () const
virtual void | update (osg::NodeVisitor &)
Public Member Functions inherited from osgVolume::Layer
| Layer ()
| Layer (const Layer &, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgVolume, Layer)
virtual void | setFileName (const std::string &filename)
virtual const std::string & | getFileName () const
void | setLocator (Locator *locator)
template<class T>
void | setLocator (const osg::ref_ptr< T > &locator)
Locator * | getLocator ()
const Locator * | getLocator () const
void | setDefaultValue (const osg::Vec4 &value)
const osg::Vec4 & | getDefaultValue () const
void | setMinFilter (osg::Texture::FilterMode filter)
osg::Texture::FilterMode | getMinFilter () const
void | setMagFilter (osg::Texture::FilterMode filter)
osg::Texture::FilterMode | getMagFilter () const
virtual osg::Image * | getImage ()
virtual const osg::Image * | getImage () const
void | setProperty (Property *property)
template<class T>
void | setProperty (const osg::ref_ptr< T > &p)
Property * | getProperty ()
const Property * | getProperty () const
void | addProperty (Property *property)
template<class T>
void | addProperty (const osg::ref_ptr< T > &p)
virtual void | dirty ()
virtual void | setModifiedCount (unsigned int)
virtual unsigned int | getModifiedCount () const
virtual osg::BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::vector< NameLayer > | Layers

## Protected Member Functions

virtual | ~CompositeLayer ()
Protected Member Functions inherited from osgVolume::Layer
virtual | ~Layer ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

Layers | _layers
Protected Attributes inherited from osgVolume::Layer
std::string | _filename
osg::ref_ptr< Locator > | _locator
osg::Vec4 | _defaultValue
osg::Texture::FilterMode | _minFilter
osg::Texture::FilterMode | _magFilter
osg::ref_ptr< Property > | _property
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Typedef Documentation

## Layers

typedef std::vector< NameLayer > osgVolume::CompositeLayer::Layers

protected

## Constructor & Destructor Documentation

## CompositeLayer() [1/2]

osgVolume::CompositeLayer::CompositeLayer | ( |  | ) |

Referenced by CompositeLayer(), and META_Object().

## CompositeLayer() [2/2]

osgVolume::CompositeLayer::CompositeLayer | ( | const CompositeLayer & | compositeLayer,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References CompositeLayer(), and osg::CopyOp::SHALLOW_COPY.

## ~CompositeLayer()

virtual osgVolume::CompositeLayer::~CompositeLayer | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addLayer() [1/2]

template<class T>

void osgVolume::CompositeLayer::addLayer | ( | const osg::ref_ptr< T > & | layer | ) |

inline

References addLayer(), and osg::ref_ptr< T >::get().

Referenced by addLayer().

## addLayer() [2/2]

void osgVolume::CompositeLayer::addLayer | ( | Layer * | layer | ) |

inline

References _layers, osgVolume::Layer::getFileName(), and osgVolume::Layer::Layer().

## clear()

void osgVolume::CompositeLayer::clear | ( |  | ) |

## getFileName()

const std::string & osgVolume::CompositeLayer::getFileName | ( | unsigned int | i | ) | const

inline

References _layers.

## getLayer() [1/2]

Layer * osgVolume::CompositeLayer::getLayer | ( | unsigned int | i | ) |

inline

References _layers, and osgVolume::Layer::Layer().

## getLayer() [2/2]

const Layer * osgVolume::CompositeLayer::getLayer | ( | unsigned int | i | ) | const

inline

References _layers, and osgVolume::Layer::Layer().

## getNumLayers()

unsigned int osgVolume::CompositeLayer::getNumLayers | ( |  | ) | const

inline

References _layers.

## META_Object()

osgVolume::CompositeLayer::META_Object | ( | osgVolume | ,
|  | CompositeLayer | )

References CompositeLayer().

## removeLayer()

void osgVolume::CompositeLayer::removeLayer | ( | unsigned int | i | ) |

inline

References _layers.

## requiresUpdateTraversal()

bool osgVolume::CompositeLayer::requiresUpdateTraversal | ( |  | ) | const

virtual

Specify whether ImageLayer requires update traversal.

Reimplemented from osgVolume::Layer.

## setFileName()

void osgVolume::CompositeLayer::setFileName | ( | unsigned int | i,
|  | const std::string & | filename )

inline

References _layers.

## setLayer() [1/2]

template<class T>

void osgVolume::CompositeLayer::setLayer | ( | unsigned int | i,
|  | const osg::ref_ptr< T > & | layer )

inline

References osg::ref_ptr< T >::get(), and setLayer().

Referenced by setLayer().

## setLayer() [2/2]

void osgVolume::CompositeLayer::setLayer | ( | unsigned int | i,
|  | Layer * | layer )

inline

References _layers, and osgVolume::Layer::Layer().

## update()

virtual void osgVolume::CompositeLayer::update | ( | osg::NodeVisitor & |  | ) |

virtual

Call update on the Layer.

Reimplemented from osgVolume::Layer.

## Member Data Documentation

## _layers

Layers osgVolume::CompositeLayer::_layers

protected

Referenced by addLayer(), getFileName(), getLayer(), getLayer(), getNumLayers(), removeLayer(), setFileName(), and setLayer().

The documentation for this class was generated from the following file:

- osgVolume/Layer